"""
Definiert ein leeres Statement,
sowie davon erbend Commando, Block, Loop, IfThen, ForLoop
first:  28.02.02 inli
update: 10.04.02
"""

class StdStatement:
    """Ein leeres Statement.
    
     Es hat als body ein (Commando, Block, Loop, IfThen, ForLoop) """
     
    def __init__(self,f=None):
        "erzeuge ein leeres Statement"
        self.father = f
        self.text = "pass"
        self.name = "name"
        self.body=None
        self.pos=(0,0,0,0)
        self.hidden=0
    def setText(self,t):
        "allgemein: setze den Text des Statements."
        self.text = t
    def setpos(self,pos):
        "Setzte die Position des Statements. pos = tupel(x,y,breite,hoehe)"
        self.pos=pos
    def is_hidden(self):
        try:
          r=self.hidden
        except:
          self.hidden=0
        return self.hidden

    def find(self,x,y):
        "Finde das Statement an Position x,y"
        result=[]

        if not self.is_hidden():
          # Erst mal alle Shne fragen
          for i in self.allbodys():
            test=i.find(x,y)
            if test != []:   #Hurra, er wars!
              result=[self]+test

        # Wenn es kein Sohn ist: Bin ich es evtl. selbst?
        if result==[]:
          try:
            if (x>self.pos[0]) & (x<(self.pos[0]+self.pos[2])) & (y>self.pos[1]) & (y<(self.pos[1]+self.pos[3])):
              if self.__class__.__name__ == "Statement":
                result=[self]
          except:
            pass
        return result

    def setBody(self,t):
        "Setze Sohn (Commando, Block, Loop, IfThen, ForLoop)"
        self.body=t
    def allbodys(self):
        "Liste alle Shne"
        if self.body==None:
          return []
        else:
          return [self.body]
          
    def size(self):
      "liefert eine sehr grobe Anschtzung des Platzbedarfs durch Tiefensuche."
      if self.allbodys()==[]:
        return 1
      else:
        r=1
        for i in self.allbodys():
          r+=i.size()
        return r

class StdCommand(StdStatement):
    "Klasse fr Anweisungen"
    def __init__(self,f=None):
        "Erzeuge eine leere Anweisung mit Inhalt 'pass'"
        self.father = f
        self.text = "pass"
        self.name = "name"
        self.body=None
        self.pos=(0,0,0,0)
    def size(self):
        "liefert eine sehr grobe Abschtzung des Platzbedarfs durch Tiefensuche."
        return 1+min(self.text.count("\n"),8)

class StdAusgabe(StdCommand):
    "Klasse fr Ausgaben"
    def __init__(self,f=None):
        "Erzeuge eine leere Anweisung mit Inhalt 'pass'"
        self.father = f
        self.text = '"Text"'
        self.name = "name"
        self.body=None
        self.pos=(0,0,0,0)

class StdEingabe(StdCommand):
    "Klasse fr Eingaben"
    def __init__(self,f=None):
        "Erzeuge eine leere Eingabe"
        self.father = f
        self.text = '???'
        self.name = "x"
        self.body=None
        self.pos=(0,0,0,0)
        self.istext=0
    def setName(self,t):
        "Setze den Namen der Funktion"
        self.name = t

class StdExitcommand(StdStatement):
    "Klasse fr Exit-Anweisungen"
    def __init__(self,f=None):
        "Erzeuge eine leere Anweisung mit Inhalt 'pass'"
        self.father = f
        self.text = "return"
        self.body=None
        self.pos=(0,0,0,0)
    def size(self):
        "liefert eine sehr grobe Abschtzung des Platzbedarfs durch Tiefensuche."
        return 1+self.text.count("\n")


class StdFunction(StdStatement):
    "Klasse fr Funktionen"
    def __init__(self,f=None):
        "Erzeugt eine leere Funktion"
        self.father = f
        self.text = ""
        self.body=None
        self.name = ""
        self.pos=(0,0,0,0)
    def setText(self,t):
        "Setze den Text der Funktion"
        self.text = t
    def setName(self,t):
        "Setze den Namen der Funktion"
        self.name = t
    def size(self):
      "liefert eine sehr grobe Anschtzung des Platzbedarfs durch Tiefensuche."
      if self.is_hidden():
        return 2
      elif self.allbodys()==[]:
        return 1
      else:
        r=1
        for i in self.allbodys():
          r+=i.size()
        return r       

class StdKlasse(StdStatement):
    "Klasse fr Klassen"
    def __init__(self,f=None):
        "Erzeuge eine leere Klasse."
        self.father = f
        self.text = ""
        self.body=None
        self.name = ""
        self.pos=(0,0,0,0)
        self.hidden=0
    def setName(self,t):
        "Setze den Namen der Funktion"
        self.name = t

    def size(self):
      "liefert eine sehr grobe Anschtzung des Platzbedarfs durch Tiefensuche."
      if self.is_hidden():
        return 2
      elif self.allbodys()==[]:
        return 1
      else:
        r=1
        for i in self.allbodys():
          r+=i.size()
        return r       
    

class StdBlock(StdStatement):
    "Klasse fr Block"
    def __init__(self,f=None):
        "Erzeuge einen leeren Block"
        StdStatement.__init__(self,f)
        self.statements = []
        self.body=None
        self.pos=(0,0,0,0)
    def appendStmt(self,s):
        "Fge ein Statement hinzu"
        self.statements.append(s)
    def insertStmt(self,s):
        "Fge ein Statement an pos s ein"
        self.statements.insert(0,s)
    def insertbelow(self,other,item):
        "Fge ein Statement unter other ein"
        found=0
        for i in self.statements:
          found=found+1
          if i==other:
            self.statements.insert(found,item)
            return 1
        return 0
    def insertabove(self,other,item):
        "Fge ein Statement unter other ein"
        found=0
        for i in self.statements:
          if i==other:
            self.statements.insert(found,item)
            return 1
          found=found+1
        return 0

    def allbodys(self):
        "Liste aller Statements"
        return self.statements
    def removeStmt(self,item):
        "lsche das Statement item aus der Liste der Shne"
        if len(self.statements)>1:
          try:
            self.statements.remove(item)
          except ValueError:
            pass

class StdLoop(StdStatement):
    "Klasse fr Schleife"
    def __init__(self,f=None):
        "erzeuge leere Schleife"
        StdStatement.__init__(self,f)
        self.condition = ""
        self.body = None
        self.pos=(0,0,0,0)
    def setCond(self,c):
        "Setze Bedingungstext"
        self.condition = c
    def setBody(self,b):
        "Setze Schleifeninhalt"
        self.body = b
        
class StdForloop(StdStatement):
    "Klasse fr for-Schleifen"
    def __init__(self,f=None):
        StdStatement.__init__(self,f)
        self.condition = ""
        self.iterator = ""
        self.body = None
        self.pos=(0,0,0,0)
    def setCond(self,c):
        "Setzte Bedingungstext"
        print "Setze",c
        self.condition = c
    def setIterator(self,c):
        "Setze Iteratortext"
        print "Setze",c
        self.iterator = c
    def setBody(self,b):
        self.body = b

class StdIfthen(StdStatement):
    "Klasse fr if..then Fallunterscheidung"
    def __init__(self,f=None):
        StdStatement.__init__(self,f)
        self.condition = ""
        self.body = None
        self.bodytrue = None
        self.bodyfalse = None
        self.pos=(0,0,0,0)
    def setCond(self,c):
        "Setze den Bedingungstext"
        self.condition = c
    def setBodytrue(self,b):
        "Setze das True-Statement"
        self.bodytrue = b
    def setBodyfalse(self,b):
        "Setzte das Falls-Statement"
        self.bodyfalse = b
    def allbodys(self):
        "Liefert Liste aller Sohn-Statements"
        r=[]
        if self.bodytrue!=None:
          r.append(self.bodytrue)
        if self.bodyfalse!=None:
          r.append(self.bodyfalse)
        return r
    def size(self):
      "liefert eine sehr grobe Anschtzung des Platzbedarfs durch Tiefensuche."
      if self.allbodys()==[]:
        return 1
      else:
        r=1
        for i in self.allbodys():
          r = max(r,i.size()) +1
        return r



def main():
  "Test-Funktion"
  print "Test: Statements anlegen"
  s1 = StdStatement()
  s1.setText("a=1")
  s2 = StdStatement()
  s1.setText("b=2")
  s2.setText("b=2")
  b=StdBlock()
  b.appendStmt(s1)
  b.appendStmt(s2)
  l=StdLoop()
  l.setCond("a>b")
  l.setBody(b)
  print "ENDE, Statements erfolgreich angelegt."

if __name__=="__main__":
  main()
  