"""
Ein kleiner debugger!
18.03.02 inli
"""

from sys import settrace, exc_info
import sys
import os
import traceback
import time
import threading
import inspect
import pprint
import copy

# 2 (leider) globale Listen zur Kommunikation zwischen Debugger und GUI
# Tracelist enthlt letzte Trace-Meldungen, breaklist sendet Nachrichten an den Debugger
global tracelist
tracelist=[]
global breaklist
breaklist=[]
global stdoutlist
stdoutlist=[]
global stdinlist,stdinrequest
stdinlist=[]
stdinrequest=[]

global debugmode
debugmode=0
pp = pprint.PrettyPrinter()

def t(frame,event,arg):
    "Tracefunktion. Wird nach jedem ausgefhrten Python-Befehl aufgerufen"
    global tracelist
    global debugmode
    global pp

    if (frame.f_locals.has_key("stdouttxt")==0) and (frame.f_locals.has_key("self")==0):
      if debugmode:
        frames = inspect.getouterframes(inspect.currentframe())[1:-3]
        #symtables = [f[0].f_locals for f in frames]
        print "TRACE: ", event, frame.f_lineno, frame.f_locals, arg
        #print pp.pprint(symtables[0])
        print "STACK:"
        for f in frames:
          l = copy.copy(f[0].f_locals)
          try:
            del l["__builtins__"]
          except KeyError:
            pass
          try:
            del l["settrace"]
          except KeyError:
            pass
          print "Zeile %d: %s" % (f[0].f_lineno,l)
        if tracelist!=[]:
          time.sleep(0.2)
      else:
        while tracelist!=[]:
          time.sleep(0.05)
  
      # Trace-Informationen in globale Traceliste schreiben.
      tracelist.append((frame.f_lineno,
                        str(frame.f_locals)+" / "+str(arg),                        
                        str(event)))
      #+" / "+str(inspect.currentframe())                        
  
      # Hat da jemand die Notbremse gezogen?
      if breaklist!=[]:
        breaklist.pop()
        raise Exception,"User Break"
        # brutale aber einzige Variante, um das Tracing zu stoppen.
      
    return t

tron  = "settrace(t)    # >>>>>>>>>>"
troff = "settrace(None) # <<<<<<<<<<"

class NewStdout:
  "Neue Stdout-Klasse, Ausgaben werden in globale stdoutlist geschrieben"
  def write(self,stdouttxt):
    "Schreibe Ausgabe in stdoutlist"
    sys.__stdout__.write("*"+stdouttxt)
    global stdoutlist
    stdoutlist.append(stdouttxt)

class NewStdin:
  "Neue Stdin-Klasse, fr zuknftiges"
  def readline(self):
    "dummy"
    global stdinlist,stdinrequest
    stdinrequest.append("?")
    while len(stdinlist)<1:
      # print "Warte auf Eingabe..."
      time.sleep(0.5)
    r=stdinlist.pop(0)
    
    return r #"Hallo" #statt sys.__stdin__.readline(self)

class Debugger:
  "Ein Python-Debugger, ermglicht Ausfhren und Debuggen von Python-code"
  def __init__(self,prg,queue):
    "Initialisiere Debugger mit Programmcode prg"
    self.prg=prg
    self.queue=queue

  def run(self):
    "Startet den Debugger"
    print "Thread RUN gestartet."

    if not debugmode:   
      sys.stdout=NewStdout()
      sys.stdin=NewStdin()
    
    # Source ausfhren in eigenem Kontext
    # Rckgabe: Tupel (Fehlerzeile,Fehlertext)
    result=(0,"")

    # Erstelle neuen Kontext g
    g={}
    g["settrace"] = settrace
    g["t"] = t

    # prg=compile(tron+"\n"+str(self.prg)+"\n"+troff, "Struktogramm", "exec")

    try:
      # exec prg in g
      exec tron+"\n"+str(self.prg)+"\n"+troff in g
    except Exception,params:
      print "### da ging was schief ###"
      settrace(None)
      # Hier wird es etwas intern: Auswerten der aufgetretenen Exception
      ty,val,tb = sys.exc_info()
      fehlertext=""
      for s in traceback.format_exception(ty,val,tb):
        fehlertext += str(s)
      print traceback.extract_tb(tb)

      err=traceback.extract_tb(tb)
      fehlerzeile=err[-1][1]

      print "Fehler in Zeile",fehlerzeile
      result=(fehlerzeile,fehlertext)
      print params
      tracelist.append((fehlerzeile,str(params),"error"))

    sys.stdout=sys.__stdout__
    sys.stdin=sys.__stdin__

    print "Thread RUN beendet."
    tracelist.append((-1000,"exit","Exit"))
    return result  


################################################################################
# TESTPROGRAMM !
################################################################################

# Mini-Program als String zum Testen des Debuggers
fdef0 = """
def fac(n):
  if n>1:
    return n * fac(n-1)
  else:
    print "Rekursionsende!"
    return 1
print "Start"
x = fac(5)
print x
print "Ende"
"""
     
fdef ="""
def fib(level, n):
  if n>2:
    return fib(level+1, n-1) + fib(level+1, n-2)
  else:
    print "Rekursionsende!"
    return 1
print "Start"
x = fib(0,9)
print x
print "Ende"
"""
        
def main():
    "Testfunktion fr den Debugger"
    global debugmode
    debugmode=1
    d=Debugger(fdef,0)
    #print "starte Programm ohne thread"
    #d.run()
    #print "ok"
    print "starte thread"
    debugthread=threading.Thread(target=d.run)
    debugthread.start()
    print "ok"
        
# call the "main" function if running this script
if __name__ == '__main__': main()

