"""
Modul: Editor fr Eigenschaften einer Bedingung bei Schleifen und IF-THENs
02.10.2002 
i.linkweiler@gmx.de
"""

from qt import *
from Statements import *

class EingabeeditWidget(QWidget):
  "Ein QT-Widget zum Bearbeiten von Eingaben"
  def __init__(self,*args):
    "Erzeuge das Widget"
    apply(QWidget.__init__,(self,) + args)
    self.setMinimumSize(320,240)
    self.resize(320,240)

    self.setCaption(_('Eingaben bearbeiten'))
    self.icon=QPixmap("./icons/find.xpm")
    self.setIcon(self.icon)

    self.t1= QLabel(_("Aufforderung zur Eingabe von <b>Text</b> per Tastatur."),self)
    self.t1.setGeometry(4,4,310,32)

    self.ok = QPushButton(_("&OK"),self,"ok")
    self.ok.setGeometry(40,210,75,24)
    self.connect(self.ok,SIGNAL("clicked()"),self.slotOk)

    self.abbruch = QPushButton(_("&Abbruch"),self,"abbruch")
    self.abbruch.setGeometry(120,210,75,24)
    self.connect(self.abbruch,SIGNAL("clicked()"),self.close)

    self.hilfe = QPushButton(_("&Hilfe"),self,"hilfe")
    self.hilfe.setGeometry(200,210,75,24)
    self.connect(self.hilfe,SIGNAL("clicked()"),self.slotHilfe)

    self.t2= QLabel(_("Hinweistext(ohne\nAnfhrungszeichen)"),self)
    self.t2.setGeometry(4,30,120,50)
    
    self.edit = QLineEdit(self)
    self.edit.setGeometry(120,40,190,20)

    self.t3= QLabel(_("Zuweisen an Variable"),self)
    self.t3.setGeometry(4,80,120,20)

    self.edit2 = QLineEdit(self)
    self.edit2.setGeometry(120,80,190,20)

    self.bg1=QButtonGroup(_("Art der Eingabe"),self)
    self.bg1.setGeometry(4,110,320,80)
    
    self.check1=QRadioButton (_("als Zahl"),self.bg1)
    self.check1.setGeometry(10,20,240,20)
    self.check2=QRadioButton (_("als Zeichenkette"),self.bg1)
    self.check2.setGeometry(10,40,240,20)

    self.exitcmd=None
    
  def setexitcmd(self,cmd):
    "<cmd> kann aufgerufen werden, wenn Dialog mit OK beendet wurde."
    self.exitcmd=cmd

  def setitem(self,item):
    "Setze das zu bearbeitende Objekt."
    self.item=item
    self.edit.setText(item.text)
    self.edit2.setText(item.name)
    try:
      self.check1.setOn(item.istext==0)
      self.check2.setOn(item.istext==1)
    except:
      pass


  def slotHilfe(self):
    import hilfe
    hilfe.zeigen("./readme/eingabe.html")

  def slotOk(self):
    "Da hat wohl jemand OK geklickt."
    #unicode QString nach ascii wandeln.
    self.item.text=unicode(self.edit.text())
    self.item.name=unicode(self.edit2.text())
    self.item.istext=self.check2.isOn()

    #self.item.text=unicode(self.edit.text()).encode("cp437", "replace")
    if self.exitcmd!=None: 
      self.exitcmd()
    self.close(1)

  def resizeEvent(self,resizeEvent):
    #self.edit.resize(self.width(),self.height() - 16 - 5)
    #self.edit.setGeometry(0,40,self.width()-2,self.height()-40)
    pass

def main():
    "Test-Funktion"
    STYLE="Qt"
    item=Eingabe(STYLE)

    a = QApplication(sys.argv)
    QObject.connect(a,SIGNAL('lastWindowClosed()'),a,SLOT('quit()'))
    w = EingabeeditWidget()
    a.setMainWidget(w)
    
    w.setitem(item)
    w.show()
    a.exec_loop()

if __name__=="__main__":
  def _(x): return x
  main()
