#!/usr/bin/env python

import sys
import os

from qt import *

TB_QUIT = 5

class MainView(QWidget):

#
# This initialises the listview
#

  def __init__(self, *args):
    apply(QWidget.__init__,(self,) + args)
    pm=QPixmap("./title.gif")
    self.setBackgroundPixmap(pm)
    ###print pm.size().width(), pm.size().height()
    #self.resize(640,480)
    ###print self.size().width(), self.size().height()

class Win(QMainWindow):

  def __init__(self, *args):
    apply(QMainWindow.__init__,(self,)+args)
    
    self.file=QPopupMenu()
    self.file.insertItem(("&New"),self.slotNew, CTRL+Key_N)
    self.file.insertItem(("&Open"),self.slotNotImpl, CTRL+Key_O)
    self.file.insertItem(("&Save"),self.slotNotImpl, CTRL+Key_S)
    self.file.insertItem(("Save &As"),self.slotNotImpl, CTRL+Key_A)
    self.file.insertItem(("&Close"),self.slotClose, CTRL+Key_C)
    self.file.insertSeparator()
    self.file.insertItem(("&Quit"),self.slotQuit, CTRL+Key_Q)
    
    self.menu=QMenuBar(self)
    self.menu.insertItem(("&File"), self.file)
    self.menu.show()
    #self.setMenu(self.menu)  

    self.toolbar=QToolBar(self, "File Operations")
    self.tool_exit = QToolButton(QPixmap("/opt/kde/share/toolbar/filenew.xpm"),
				 'New', '',
				 self.slotNew,
				 self.toolbar, 'New')
    self.tool_exit = QToolButton(QPixmap("/opt/kde/share/toolbar/fileopen.xpm"),
				 'Open...', '',
				 self.slotNotImpl,
				 self.toolbar, 'Open...')
    self.tool_exit = QToolButton(QPixmap("/opt/kde/share/toolbar/exit.xpm"),
				 'Quit', '',
				 self.slotQuit,
				 self.toolbar, 'Quit')
    self.tool_close = QToolButton(QPixmap("/opt/kde/share/toolbar/delete.xpm"),
				 'Close', '',
				 self.slotClose,
				 self.toolbar, 'Close')
    #self.addToolBar(self.toolbar)
    self.toolbar.show()

    self.connect(self.toolbar
                ,SIGNAL("clicked(int)")
                ,self.commandCallback
                )
                             
    self.statusbar=QStatusBar(self)
    label1=QLabel(self.statusbar,"Welcome to GPStool")
    label2=QLabel(self.statusbar,"00")
    label1.show()
    label2.show()
    self.statusbar.addWidget(label1,90)
    self.statusbar.addWidget(label2,10)
    self.statusbar.show()
    #self.setStatusBar(self.statusbar)

    self.view=MainView(self)
    self.setCentralWidget(self.view)
    #self.resize(640,480)
    self.view.show()
    self.view.setFocus()
    
  def closeEvent(self, QCloseEvent):
    QCloseEvent.accept()
    
  def slotNew(self):
    global toplevels
    toplevels.append(Win())
    toplevels[-1].show()
    
  def slotClose(self):
    self.close()
    
  def slotQuit(self):
    sys.exit()
    
  def slotNotImpl(self):
    print "not yet implemented..."
    print "OR: not implemendet yet."
    pass
    
  def commandCallback(self, item):
    if item==TB_QUIT:    
      self.slotQuit()
                             
def main():
  global toplevels
  app=QApplication(sys.argv)   #,"GPStool")
  toplevels=[Win()]
  app.setMainWidget(toplevels[0])
  toplevels[0].show()
  app.exec_loop()
  
if __name__=="__main__":
  main()

