"""
Modul: Editor fr Eigenschaften einer Bedingung bei Schleifen und IF-THENs
02.03.2002 
i.linkweiler@gmx.de
"""

from qt import *
from Statements import *
import options

class SetupWidget(QWidget):
  "Ein QT-Widget zum Bearbeiten von Anweisungen"
  def __init__(self,*args):
    "Erzeuge das Widget"
    apply(QWidget.__init__,(self,) + args)
    self.setMinimumSize(320,160)
    self.resize(320,160)

    self.setCaption(_('Programm-Einstellungen'))
    self.icon=QPixmap("./icons/find.xpm")
    self.setIcon(self.icon)

    self.ok = QPushButton(_("&OK"),self,"ok")
    self.ok.setGeometry(40,135,75,24)
    self.connect(self.ok,SIGNAL("clicked()"),self.slotOk)

    self.abbruch = QPushButton(_("&Abbruch"),self,"abbruch")
    self.abbruch.setGeometry(120,135,75,24)
    self.connect(self.abbruch,SIGNAL("clicked()"),self.close)

    self.hilfe = QPushButton(_("&Hilfe"),self,"hilfe")
    self.hilfe.setGeometry(200,135,75,24)
    self.connect(self.hilfe,SIGNAL("clicked()"),self.slotHilfe)

    self.t1= QLabel(_("Sprache"),self)
    self.t1.setGeometry(4,20,140,20)

    self.auswahl = QListBox(self)
    self.auswahl.setGeometry(140,10,160,64)
    self.auswahl.insertStrList(["DE = Deutsch","EN = English","UD = other"])
    self.exitcmd=None
    
    self.t2= QLabel(_("Debugger-Geschwindigkeit"),self)
    self.t2.setGeometry(4,90,140,20)
   
    self.slider= QSlider(1,10,1,1,0,self)
    self.slider.setGeometry(140,90,160,16)

    self.t3= QLabel(_("schnell"),self)
    self.t3.setGeometry(140,110,80,20)
    self.t4= QLabel(_("langsam"),self)
    self.t4.setGeometry(260,110,80,20)
    
  def setexitcmd(self,cmd):
    "<cmd> kann aufgerufen werden, wenn Dialog mit OK beendet wurde."
    self.exitcmd=cmd

  def setitem(self,item):
    "Setze das zu bearbeitende Objekt."
    s=item.get("language")
    self.auswahl.setSelected(0,s=="DE")
    self.auswahl.setSelected(1,s=="EN")
    self.auswahl.setSelected(2,s=="UD")
    self.slider.setValue(item.getvalue("debugspeed"))
    self.item=item

  def slotHilfe(self):
    import hilfe
    hilfe.zeigen("./readme/anweisung.html")

  def slotOk(self):
    "Da hat wohl jemand OK geklickt."

    altesprache=self.item.get("language")
    if self.auswahl.isSelected(0): self.item.set("language","DE")
    if self.auswahl.isSelected(1): self.item.set("language","EN")
    if self.auswahl.isSelected(2): self.item.set("language","UD")
    self.item.set("debugspeed",self.slider.value())
    print self.item.options
    self.item.sichern()
    
    if altesprache<>self.item.get("language"):
      QMessageBox.about(self, "PyNassi", "Please restart PyNassi!\nBitte PyNassi neu starten!")

    
    #unicode QString nach ascii wandeln.
    #self.item.text=unicode(self.edit.text())
    #self.item.text=unicode(self.edit.text()).encode("cp437", "replace")

    if self.exitcmd!=None: 
      self.exitcmd()
    self.close(1)

  def resizeEvent(self,resizeEvent):
    #self.edit.resize(self.width(),self.height() - 16 - 5)
    #self.edit.setGeometry(0,40,self.width()-2,self.height()-40)
    pass

def main():
    "Test-Funktion"
    STYLE="Qt"
    item=options.Options()
    item.laden()

    a = QApplication(sys.argv)
    QObject.connect(a,SIGNAL('lastWindowClosed()'),a,SLOT('quit()'))
    w = SetupWidget()
    a.setMainWidget(w)
    
    w.setitem(item)
    w.show()
    a.exec_loop()

if __name__=="__main__":
  def _(x): return x
  main()
