"""
Ein Widget zum Anzeigen von Text.
berwacht per Timer die globalen Ein- und Ausgabelisten
stdoutlist, und gibt ggf. in der Listbox aus.
"""

import sys
import os
from qt import *
from debugger import *

class StdoutWidget(QListBox):
  """
  Ein Widget zum Anzeigen von Text.
  berwacht per Timer die globale Ausgabeliste
  stdoutlist, und gibt ggf. in der Listbox aus.
  """
  def __init__(self,*args):
    "Erzeuge neues Widget"
    apply(QListBox.__init__,(self,) + args)
    self.setMinimumSize(128,128)
    self.resize(320,160)
    self.icon=QPixmap("./icons/find.xpm")
    self.setIcon(self.icon)
    self.insertItem(_("Hallo Welt"))
    self.setCaption(_('Textausgabe (stdout)'))
    self.timer=QTimer(self)
    self.connect( self.timer, SIGNAL("timeout()"), self.timeout ) 
    self.timer.start(200)
    self.buffer=""
    self.lastoutput=""

  def closeEvent(self, QCloseEvent):
    "Ich muss mich schlieen"
    print "Stdout wurde geschlossen."
    self.timer.stop()
    QCloseEvent.accept()

  def slotClose(self):
    self.close(1)

  def timeout( self ):
    "stdoutliste Auslesen und an Ausgabe weitergeben"
    # print "timer"
    global stdoutlist,stdinlist,stdinrequest

    # Ist etwas auszugeben?
    while stdoutlist!=[]:
      t=stdoutlist.pop(0)
      self.write(unicode(t,"cp437"))
      self.lastoutput=unicode(t,"cp437")

    # Anfrage nach Eingabe?
    if stdinrequest!=[]:
      stdinrequest.pop(0)
      q=QInputDialog.getText(_("Bitte eingeben:"),self.lastoutput,"", self)
      stdinlist.append(str(q[0]))
   
  def write(self,txt):
    "Ausgabe von Text ins Widget"
    for c in txt:
      if c>=" ":
        self.buffer += c
      elif c=="\n":

        self.insertItem(self.buffer)
        self.setSelected(self.count()-1,1)
        self.setSelected(self.count()-1,0)  
        self.setBottomItem(self.count()-1)

        if self.count()>50:
          self.removeItem(0)
        self.buffer=""



def main():
    "Zum Test:"

    global stdoutlist
    stdoutlist=["huhu\n","tata\n","haha\n"]
    a = QApplication(sys.argv)
    QObject.connect(a,SIGNAL('lastWindowClosed()'),a,SLOT('quit()'))
    w = StdoutWidget()
    a.setMainWidget(w)  
    w.show()

    a.exec_loop()

if __name__=="__main__":
  def _(x): return x
  main()
